//
// Copyright (c) SAS Institute Inc.
//

function OnFinish(selProj, selObj)
{
    var oldSuppressUIValue = true;
    try
    {
        oldSuppressUIValue = dte.SuppressUI;
        var bSilent = wizard.FindSymbol("SILENT_WIZARD");
        dte.SuppressUI = bSilent;

        var strProjectName = wizard.FindSymbol("PROJECT_NAME");
        var strProjectPath = wizard.FindSymbol("PROJECT_PATH");
        var strTemplatePath = wizard.FindSymbol("TEMPLATES_PATH");
        var strTemplateFile = strTemplatePath + "\\ClassLibrary.vbproj"; 
        
	    var project = CreateVSProject(strProjectName, ".vbproj", strProjectPath, strTemplateFile);
        if( project )
        {
            strProjectName = project.Name;  //In case it got changed     
            wizard.AddSymbol("SAFE_NAMESPACE_NAME", strProjectName);
				
            var item;
            var editor;

            var strRawGuid = wizard.CreateGuid();
            wizard.AddSymbol("GUID_ASSEMBLY", wizard.FormatGuid(strRawGuid, 0));
            
   			// create ClsID for custom task
	        var strTaskGuid = wizard.CreateGuid();
	        wizard.AddSymbol("GUID_TASK", wizard.FormatGuid(strTaskGuid, 0));


            strTemplateFile = strTemplatePath + "\\AssemblyInfo.vb"; 
            item = AddFileToVSProject("AssemblyInfo.vb", project, project.ProjectItems, strTemplateFile, false);
            if( item )
            {
                item.Properties("SubType").Value = "Code";
            }

			// add the form
            strTemplateFile = strTemplatePath + "\\CustomTaskForm1.vb"; 
            item = AddFileToVSProject("CustomTaskForm1.vb", project, project.ProjectItems, strTemplateFile, false);
            if( item )
            {
                item.Properties("SubType").Value = "Code";
            }         
                         
            // add the class         
            strTemplateFile = strTemplatePath + "\\Class.vb"; 
            item = AddFileToVSProject("CustomTask1.vb", project, project.ProjectItems, strTemplateFile, false);
            if( item )
            {
                item.Properties("SubType").Value = "Code";
                editor = item.Open(vsViewKindPrimary);
                editor.Visible = true;
            }
            
            // add custom references
			var refs = project.Object.References;
			var ref;
			ref = refs.Add("System");
			ref = refs.Add("System.Data");
			ref = refs.Add("System.Drawing");
			ref = refs.Add("System.Windows.Forms");
			ref = refs.Add("System.XML");
			ref = refs.Add(GetSASEGTaskPath() + "\\BIClientTasks\\3.0\\SAS.EG.AddIns.dll");
                    
            project.Save();
        }
        
        return 0;
    }
    catch(e)
    {   
        switch(e.number)
        {
        case -2147024816 /* FILE_ALREADY_EXISTS */ :
            return -2147213313;

        default:
            SetErrorInfo(e);
            return e.number;
        }
    }
    finally
    {
        dte.SuppressUI = oldSuppressUIValue;
    }
}

function GetSASEGTaskPath()
{
	var oShell, sharedFilesLoc;

	// init to default location	
	sharedFilesLoc = "C:\\Program Files\\SAS\\Shared Files\\BIClientTasks\\3.0";

	try
	{	
		oShell = new ActiveXObject("WScript.Shell");
		// key off of SAS shared files location in registry
		sharedFilesLoc = oShell.RegRead("HKLM\\SOFTWARE\\SAS Institute Inc.\\Common Data\\Shared Files\\");
	}
	catch(e)
	{
		if( e.description.length > 0 )
			SetErrorInfo(e);
	}
	
	return sharedFilesLoc;
}

